AC_DEFUN(LAC_SET_Default_GSSAPI,
[
       # enable a default implementation
       lac_enable_gssapi_cleartext="yes"
])

AC_DEFUN(LAC_GSSAPI_ARGS,
[

AC_ARG_ENABLE(gssapi-cleartext,
        [  --enable-gssapi-cleartext     configure cleartext version],
        [lac_enable_gssapi_cleartext="$enableval"],
        [lac_enable_gssapi_cleartext="no"])
AC_ARG_ENABLE(gssapi-ssleay,
        [  --enable-gssapi-ssleay          configure SSLEAY version],
        [lac_enable_gssapi_ssleay="$enableval"],
        [lac_enable_gssapi_ssleay="no"])

# The abstract "gssapi" module must enable one of the implementation
# modules...

if test "$lac_enable_gssapi_cleartext" = "yes" \
        -a "$lac_enable_gssapi_ssleay" = "yes" ; then
    AC_MSG_ERROR(Cannot enable both GSSAPI_cleartext and GSSAPI_SSLEAY)
fi

if test "$lac_enable_gssapi" = "yes" ; then
    if test "$lac_enable_gssapi_cleartext" != "yes" \
            -a "$lac_enable_gssapi_ssleay" != "yes" ; then

        LAC_SET_Default_GSSAPI
    fi
fi

AC_CACHE_VAL(lac_cv_enable_gssapi_cleartext, [dnl
   lac_cv_enable_gssapi_cleartext="$lac_enable_gssapi_cleartext"
])
AC_CACHE_VAL(lac_cv_enable_gssapi_ssleay, [dnl
    lac_cv_enable_gssapi_ssleay="$lac_enable_gssapi_ssleay"
])



AC_CHECK_LIB(crypt, crypt, [libcrypt="-lcrypt"], [libcrypt=""])

# always configure for one of the implementations
if test "$lac_enable_gssapi_ssleay" = "yes" ; then
    # GSSAPI_SSLEAY must be explicitly enabled
    gssapi_cflags="\$(SSL_GLOBUS_CFLAGS)"
    gssapi_ldflags="\$(SSL_GLOBUS_LDFLAGS)"
    gssapi_libs="-lgss \$(SSL_GLOBUS_LIBS)"
    gssapi_app_cflags="\$(SSL_APP_CFLAGS)"
    gssapi_app_ldflags="\$(SSL_APP_LDFLAGS)"
    gssapi_app_libs="-lgss \$(SSL_APP_LIBS)"
else
    # GSSAPI_cleartext is the default implementation
    gssapi_cflags=""
    gssapi_ldflags=""
    gssapi_libs="-lgss ${libcrypt}"
    gssapi_app_cflags=""
    gssapi_app_ldflags=""
    gssapi_app_libs="-lgss ${libcrypt}"
fi

dnl these values get stuffed into makefile_header

AC_SUBST(gssapi_cflags)
AC_SUBST(gssapi_ldflags)
AC_SUBST(gssapi_libs)
AC_SUBST(gssapi_app_cflags)
AC_SUBST(gssapi_app_ldflags)
AC_SUBST(gssapi_app_libs)

])

AC_DEFUN(LAC_GSSAPI,
[
    LAC_GSSAPI_ARGS
])


