dnl Configuration file for the Heartbeat Monitor

AC_DEFUN(LAC_HBM_ARGS,
[


AC_CACHE_CHECK(HBM data collector host, hbm_cv_dc_host, [dnl
AC_ARG_WITH(hbm-dc-host,
	[  --with-hbm-dc-host=value      name of the default data collector],
	[hbm_cv_dc_host="$withval"],
	[hbm_cv_dc_host="www.globus.org"])
])

AC_CACHE_CHECK(HBM data collector IP number, hbm_cv_dc_ipnum, [dnl
AC_ARG_WITH(hbm-dc-ipnum,
	[  --with-hbm-dc-ipnum=value     IP number of the default data collector [overrides --with-hbm-dc-host]],
	[hbm_cv_dc_ipnum="$withval"],
	[hbm_cv_dc_ipnum="no"])
])

AC_CACHE_CHECK(HBM data collector port, hbm_cv_dc_port, [dnl
AC_ARG_WITH(hbm-dc-port,
	[  --with-hbm-dc-port=value      port number for default data collector],
	[hbm_cv_dc_port="$withval"],
	[hbm_cv_dc_port="12003"])
])

AC_CACHE_CHECK(HBM collection interval, hbm_cv_dc_interval, [dnl
AC_ARG_WITH(hbm-dc-interval,
	[  --with-hbm-dc-interval=value  interval (secs) in which checkpoints are written to stable storage[5 seconds]],
	[hbm_cv_dc_interval="$withval"],
	[hbm_cv_dc_interval="30"])
])

AC_CACHE_CHECK(HBM local monitor registration port, hbm_cv_lm_reg_port, [dnl
AC_ARG_WITH(hbm-lm-reg-port,
	[  --with-hbm-lm-reg-port=value  port number at which the local monitor looks for registration requests.],
	[hbm_cv_lm_reg_port="$withval"],
	[hbm_cv_lm_reg_port="12001"])
])

AC_CACHE_CHECK(HBM local monitor data collector port, hbm_cv_lm_dc_port, [dnl
AC_ARG_WITH(hbm-lm-dc-port,
	[  --with-hbm-lm-dc-port=value   port number at which the data collector can contact the local monitor],
	[hbm_cv_lm_dc_port="$withval"],
	[hbm_cv_lm_dc_port="12002"])
])

AC_CACHE_CHECK(HBM report interval, hbm_cv_lm_interval, [dnl
AC_ARG_WITH(hbm-lm-interval,
	[  --with-hbm-lm-interval=value  interval (secs) in which the HBM generates heartbeats [5 seconds]],
	[hbm_cv_lm_interval="$withval"],
	[hbm_cv_lm_interval="5"])
])


dnl END of LAC_HBM_ARGS
])



AC_DEFUN(LAC_HBM_PROGS,
[

AC_PATH_PROGS(PS, ps, true)


dnl Values for "hbmcl.conf"
DC_HOST_NAME="HBMDCHostname:  $hbm_cv_dc_host"

dnl Ip number overides HOST_NAME if it is defined
dnl Only provide the one which is valid
if test "X$hbm_cv_dc_ipnum" != "Xno" ; then
  DC_HOST_NAME=
  DC_HOST_IPNUM="HBMDCIPNum: $hbm_cv_dc_ipnum"
else
  DC_HOST_IPNUM=
fi

DC_PORT="HBMDCPortNum:   $hbm_cv_dc_port"

AC_SUBST(DC_HOST_NAME)
AC_SUBST(DC_HOST_IPNUM)
AC_SUBST(DC_PORT)


dnl Values for "hbmdc.conf"

DC_HBMSG_PORT=$hbm_cv_dc_port
DC_MSG_INTERVAL=$hbm_cv_dc_interval  dnl default = 5

AC_SUBST(DC_HBMSG_PORT)
AC_SUBST(DC_MSG_INTERVAL)

dnl Values for "hbmlm.conf"
LM_REG_PORT=$hbm_cv_lm_reg_port
LM_DC_PORT=$hbm_cv_lm_dc_port
LM_REPORT_INTERVAL=$hbm_cv_lm_interval  dnl default = 5


AC_SUBST(LM_REG_PORT)
AC_SUBST(LM_DC_PORT)
AC_SUBST(LM_REPORT_INTERVAL)


])


AC_DEFUN(LAC_HBM,
[
LAC_HBM_ARGS
LAC_HBM_PROGS

dnl NO -64 if its an IRIX

case "$target" in
  mips-sgi-irix6* )       PLATFORMCFLAGS="-DUSE_WAITPID"
        CFLAGS="`echo $CFLAGS | sed -e 's/-64//'` -n32"
        LDFLAGS="`echo $LDFLAGS | sed -e 's/-64//'` -n32"
    ;;
esac



])

