/******************************************************************************
CIF_Message.C

Description:

  Message buffer class

CVS Information:

  $Source$
  $Date$
  $Revision$
  $State$
  $Author$
******************************************************************************/

/******************************************************************************
			     Include header files
******************************************************************************/
#include "CIF_Message.H"


/******************************************************************************
			Define methods for CIF_Message
******************************************************************************/

/* XXX - need to set CIF::status and check state */

/*
 * CIF_Message::CIF_Message()
 */
CIF_Message::CIF_Message()
{
    object_state = OBJECT_STATE_INACTIVE;
    CIF::status = CIF::STATUS_SUCCESS;
}


/*
 * CIF_Message::activate()
 */
CIF_Bool
CIF_Message::activate(
    const CIF_Message_Info &		info_arg)
{
    if (object_state == OBJECT_STATE_ACTIVE)
    {
	deactivate();
    }

    info = info_arg;
    data = new CIF_Byte [info.size];

    CIF::status = CIF::STATUS_SUCCESS;
    return true;
}	
/* CIF_Message::activate() */

/*
 * CIF_Message::get_Data()
 */
CIF_Byte *
CIF_Message::get_Data()
{
    CIF::status = CIF::STATUS_SUCCESS;
    return(data);
}
/* CIF_Message::get_Data() */

/*
 * CIF_Message::get_Info()
 */
CIF_Message_Info
CIF_Message::get_Info()
{
    CIF::status = CIF::STATUS_SUCCESS;
    return(info);
}
/* CIF_Message::get_Info() */

/*
 * CIF_Message::deactivate()
 */
CIF_Bool
CIF_Message::deactivate()
{
    if (object_state == OBJECT_STATE_ACTIVE)
    {
	delete [] data;
    }

    object_state = OBJECT_STATE_INACTIVE;

    CIF::status = CIF::STATUS_SUCCESS;
    return true;
}	
/* CIF_Message::deactivate() */

/*
 * CIF_Message::~CIF_Message()
 */
CIF_Message::~CIF_Message()
{
    if (object_state == OBJECT_STATE_ACTIVE)
    {
	deactivate();
    }
    
    object_state = OBJECT_STATE_DELETED;
    CIF::status = CIF::STATUS_SUCCESS;
}


