/******************************************************************************
Nexus_Monitor.H

Description:

  A simple monitor class built using nexus mutexes and condition variables

CVS Information:

  $Source$
  $Date$
  $Revision$
  $State$
  $Author$
******************************************************************************/

#if !defined(CIF_INCLUDE_NEXUS_MONITOR)
#define CIF_INCLUDE_NEXUS_MONITOR 1

/******************************************************************************
			     Include header files
******************************************************************************/
#include "Nexus.H"

#include "globus_common.h"
#include "nexus.h"


/******************************************************************************
			  Define Nexus_Monitor class
******************************************************************************/
class
Nexus_Monitor
{
    public:
    Nexus_Monitor(
	ARG_INMOD nexus_mutex_t *	mutex_arg,
	ARG_INMOD nexus_cond_t *	cond_arg = (
	    (nexus_cond_t *) GLOBUS_NULL));

    public:
    ~Nexus_Monitor();
    
    public:
    void
    wait(
	ARG_IN const long		timeout = -1);
    
    public:
    void
    signal();

    public:
    void
    broadcast();
    
    private:
    nexus_mutex_t *			mutex;
    nexus_cond_t *			cond;
};

#endif /* CIF_INCLUDE_NEXUS_MONITOR */
